/// <reference types="bunyan" />
import { IIstanbulModule, IIstanbulProcessMetrics, IExtendedIstanbulMetrics } from './istanbul-to-footprints-contract';
import { IFootprintsFile } from '../contracts';
import { AgentConfig } from '../config';
import bunyan = require('bunyan');
export declare class IstanbulToFootprints {
    private cfg;
    private totalTests;
    private eidToHitsIndex;
    private uniqueIdToElement;
    private testNameToTestData;
    private fileToSourceMapConsumer;
    private fileNameToAppFile;
    private globalCoverageContainer;
    private previousIstanbulCounters;
    private nycFinalReportData;
    private shortNameToFileMapper;
    private logger;
    constructor(cfg: AgentConfig, logger: bunyan);
    private resetState();
    createFootprintsPackageFromQueue(queuedFootprints: IExtendedIstanbulMetrics[], extraData: IFootprintsFile): IFootprintsFile;
    createFootprintsPackageFromRawData(rawData: IExtendedIstanbulMetrics, extraData: IFootprintsFile): IFootprintsFile;
    private convertIstanbulDataToFootprints(footprintsElement, result, istanbulMaps?);
    private handleBranchesData(istanbulModule, moduleWithMaps, sourceMap, relPath, fullPath, file, test);
    private handleFunctionsData(istanbulModule, moduleWithMaps, sourceMap, relPath, fullPath, file, test);
    private addDeclarationFootprints(funcInfo, sourceMap, relPath, filePath, file, fullpath, test, hits);
    private getSourceMapForFile(relPath);
    private addOrUpdateElementHits(testData, elementUniqueId, element, hits);
    private getOrCreateTestData(testName, executionId, localTime, result);
    private getOrCreateMethodElement(uniqueId, file);
    private getOrCreateBranchElement(uniqueId, file);
    private getOrCreateFootprintsAppFile(fileName, app);
    private createFootprintsAppData(extraData);
    private readSourceMapData(sourceMaps, start, coveragePath, fullPath);
    private fixRelPath(p1, p2);
    private adjustPathSlashes(filePath);
    protected getIstanbulCounters(): IIstanbulProcessMetrics;
    private getCoverageObject();
    private relativeModulePaths;
    getRelativeModulePath(module: IIstanbulModule): string;
    protected formatLoc(loc: {
        column: number;
        line: number;
    }): string;
    getCurrentFootprints(): IIstanbulProcessMetrics;
    protected getIstanbulCountersDiff(currentCounters: IIstanbulProcessMetrics): IIstanbulProcessMetrics;
    private logDiff(diff);
    private newNumberArray(length);
    private getUniqueId(uniqueIdKey, moduleName);
    private resolveModule(coverageObject, moduleName);
    private createSLMapping(fullPath);
    private loadOriginalModules();
    private mapShortNamesToFiles();
}
