/// <reference types="bunyan" />
import { IFootprintsFile, IFootprintsHandler } from "../contracts";
import { AgentConfig } from "../config";
import * as bunyan from 'bunyan';
export interface IProductionDataMap {
    meta: {
        createdAt: number;
        lastModified: number;
        bsid: string;
        hostName: string;
        pid: number;
        customerId: string;
        appName: string;
        branchName: string;
        buildName: string;
        labId: string;
    };
    methodsHits: IMap<number>;
}
export interface IMap<T> {
    [name: string]: T;
}
export declare class ProductionFootprintsHandler implements IFootprintsHandler {
    private metaData;
    private logger;
    private methodIdToHits;
    private filename;
    private httpConfig;
    private httpClient;
    private agentConfig;
    private collectionStartDate;
    private saveToFile;
    private sendToServer;
    constructor(cfg: AgentConfig, logger: bunyan);
    private setupProdListenerModes();
    private initHttpConfig(cfg);
    handleFootprints(footprintsPacket: IFootprintsFile, callback: (err: Error) => void): void;
    private saveAndSendMethodsHits(packetToSend);
    private getHitFiles(packetToSend);
    private convertFootprintsToProductionData(footprintsPacket);
    private convertAndSubmitToServer(footprintsPacket);
    private addHitsFromFootprints(files);
    private tryParseFileContent(fileContent);
    private validateConfig(config);
    private addHitsFromFile();
    private writeDataToFile();
    private createFilePath(config);
    private combineArgsWithDash(...args);
    private updateHits(methodsHitFromFile);
    toJSonObject(): {
        meta: {};
        methodsHits: {
            [methodId: string]: number;
        };
    };
}
